%MACRO DISP2(A1DISP2=,
	A2DISP2=,
	A3DISP2=);
OPTIONS NODATE NONUMBER;

data _null_;
set mdisp2;
CALL SYMPUT("Q",PUT(LQ,4.1));
CALL SYMPUT("DSE",PUT(LDSE,4.2));
CALL SYMPUT("DSM",PUT(LDSM,4.2));
CALL SYMPUT("LOC",PUT(LLOC,4.0));
CALL SYMPUT("NUM",PUT(LNUM,4.0));
CALL SYMPUT("LBOUND",PUT(LLBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(LCILEVEL,4.1));
run;


%IF %UPCASE(&A2DISP2)=Y %THEN %DO;
data _null_;
set ev2;
CALL SYMPUT("ULOW",PUT(LULOW,4.0));
CALL SYMPUT("UHIGH",PUT(LUHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(LUINCRE,4.0));
CALL SYMPUT("UDIV",PUT(LUDIV,4.0));
CALL SYMPUT("SELOW",PUT(LSELOW,4.0));
CALL SYMPUT("SEHIGH",PUT(LSEHIGH,4.0));
CALL SYMPUT("SEINCRE",PUT(LSEINCRE,4.0));
CALL SYMPUT("SEDIV",PUT(LSEDIV,4.0));
CALL SYMPUT("SMLOW",PUT(LSMLOW,4.0));
CALL SYMPUT("SMHIGH",PUT(LSMHIGH,4.0));
CALL SYMPUT("SMINCRE",PUT(LSMINCRE,4.0));
CALL SYMPUT("SMDIV",PUT(LSMDIV,4.0));
RUN;
%END;
%ELSE %IF %UPCASE(&A2DISP2)=N %THEN %DO;
data _null_;
CALL SYMPUT("ULOW",PUT(950,4.0));
CALL SYMPUT("UHIGH",PUT(1000,4.0));
CALL SYMPUT("UINCRE",PUT(50,4.0));
CALL SYMPUT("UDIV",PUT(10,4.0));
CALL SYMPUT("SELOW",PUT(22,4.0));
CALL SYMPUT("SEHIGH",PUT(22,4.0));
CALL SYMPUT("SEINCRE",PUT(10,4.0));
CALL SYMPUT("SEDIV",PUT(10,4.0));
CALL SYMPUT("SMLOW",PUT(22,4.0));
CALL SYMPUT("SMHIGH",PUT(22,4.0));
CALL SYMPUT("SMINCRE",PUT(10,4.0));
CALL SYMPUT("SMDIV",PUT(10,4.0));
RUN;
%END;

%IF %UPCASE(&A3DISP2)=Y %THEN %DO;
data _null_;
set smp2;
CALL SYMPUT("MEAN",PUT(LMEAN,6.3));
CALL SYMPUT("SE",PUT(LSE,6.3));
CALL SYMPUT("SM",PUT(LSM,6.3)); 
run;
%END;
%ELSE %IF %UPCASE(&A3DISP2)=N %THEN %DO;
data _null_;
CALL SYMPUT("MEAN",PUT(100,6.3));
CALL SYMPUT("SE",PUT(2.2,6.3));
CALL SYMPUT("SM",PUT(2.46,6.3)); 
run;
%END;

%MACRO COMPUTE;
   F1 = (1 - PROBNORM((5 - LLU)/SIGMA)) ** 6;
   SN2 = SQRT(12);
   PM2 = PROBNORM (SN2 * -LLU / SIGMA);
   PB2 = 1 - PROBNORM ((-LLU - 15) / SIGMA);
   F2 = PB2 ** 12 - PM2;
   SN3 = SQRT(24);
   PM3 = PROBNORM (SN3 * -LLU / SIGMA);
   P2 = PROBNORM ((-LLU - 15) / SIGMA) - PROBNORM ((-LLU - 25) / SIGMA);
   P3 = 1 - PROBNORM ((-LLU - 15) / SIGMA);
   F3 = P3**24 + 24*P2*P3**23 + 276*P2*P2*P3**22 - PM3;
   OVERBD = MAX(F1, F2, F3);
%mend compute;



%MACRO CALDISP2;
DATA TABD;
   DM =0.10;
   DSE = &DSE;
   DSM = &DSM;
   Q = &Q;
   LIM = 100 - Q;
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   CALL SYMPUT("TOT",PUT(N, 5.0));
   Z = PROBIT(SQRT(&CILEVEL / 100));
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SEBOUND = 60;
   SMLIM = 60;
   NEXTM = 0.2;
  DO SE = DSE TO SEBOUND BY DSE;
   MEANL = NEXTM;
   SMBOUND = SMLIM;
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
  DO SM = DSM TO SMBOUND BY DSM;
   IF MEANL =. THEN GOTO OVER;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   DO MEANADJ = MEANL TO LIM BY DM;
   LLU = MEANADJ - Z *SQRT(MVAR / N);
%COMPUTE
   IF OVERBD > &LBOUND/100 THEN DO;
     MEANL = MEANADJ;
     GOTO SKIP;
                                END;
   END;
    MEANL =.;
 IF SE=DSE THEN DO;
   SMLIM = SM - DSM;
   MEAN = MEANL + Q;
   OUTPUT;
   SM = 90;
   GOTO OVER;
                END;
 IF SM=DSM THEN DO; SE = 90; GOTO OVER; END;
SKIP:
   MEAN = MEANL + Q;
   OUTPUT;
IF SM = DSM THEN NEXTM = MEANL;
OVER:
  END;
 END;
KEEP N NN L MEAN SE SM OVERBD;
PROC SORT DATA=TABD; BY SE SM;


%MEND CALDISP2;

%MACRO PRTDISP2;
options ls=132;

PROC TABULATE DATA=TABD FORMAT=6.2 FORMCHAR='          ';
  CLASS SE SM;
  FORMAT SE 6.2 SM 6.2;
  VAR MEAN;
  TABLE SE, SUM*MEAN = ' ' * (SM = ' ')/rts=8;
  KEYLABEL SUM = 'STANDARD DEVIATION OF LOCATION MEANS';
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "LOWER BOUND = &LBOUND, CONFIDENCE LEVEL = &CILEVEL";
TITLE4 'TABLE ENTRIES ARE LOWER LIMITS ON THE MEAN';
TITLE5 "OF &TOT ASSAYS-&NUM ASSAYS AT EACH OF &LOC DIFFERENT LOCATIONS";
TITLE6 'SE IS THE POOLED WITHIN LOCATION STANDARD DEVIATION';
TITLE7 'STANDARD DEVIATIONS AND MEANS ARE EXPRESSED IN % CLAIM';
run;

%MEND PRTDISP2;


%MACRO EVDISP2;

%MACRO SIGDISP2;
%CALDISP2
   %DO U = &ULOW %TO &UHIGH %BY &UINCRE;
      %DO SIGSE = &SELOW %TO &SEHIGH %BY &SEINCRE;
         %DO SIGSM = &SMLOW %TO &SMHIGH %BY &SMINCRE;

  DATA SAVE2;
    SET TABD END = LAST;
   U = &U / &UDIV;
   DSE = &DSE;
   DSM = &DSM;
   SIGSE = &SIGSE / &SEDIV;
   SIGSM = &SIGSM / &SMDIV;
   SIGSM2 = SIGSM * SIGSM;
   EXPSE2 = SIGSE * SIGSE;
   EXPSM2 = EXPSE2 + NN * SIGSM * SIGSM;
   PMEAN = 1 - PROBNORM((MEAN - U) * SQRT((N) / EXPSM2));
   PSE = PROBCHI(L * (NN - 1) * SE * SE / EXPSE2, L * (NN -1))
         - PROBCHI(L * (NN - 1) * (SE - DSE) * (SE - DSE) /
         EXPSE2, L * (NN - 1));
   PSM = PROBCHI((L - 1) * NN * SM * SM / EXPSM2, L - 1)
         - PROBCHI((L - 1) * NN * (SM - DSM) * (SM - DSM) /
         EXPSM2, L - 1);
   P = PMEAN * PSE * PSM;
   PSUM + P;
   IF LAST THEN OUTPUT;
   RUN;
   PROC APPEND BASE = SAVES2E DATA = SAVE2;
   RUN;

       %END;
      %END;
     %END;

%MEND SIGDISP2;

%SIGDISP2

PROC PRINT DATA = SAVES2E split = '*';
  label U = 'MEAN'
       SIGSE = 'WITHIN LOCATION*STD DEV'
       SIGSM = 'BETWEEN LOCATION* STD DEV'
       PSUM = 'PROBABILITY*OF*PASSING';
   VAR U SIGSE SIGSM PSUM;
TITLE1 "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "PROBABILITY OF PASSING DISSOLUTION ACCEPTANCE LIMIT TABLE";
TITLE4 "WITH &NUM ASSAYS AT EACH OF &LOC LOCATIONS";
TITLE5 "CONFIDENCE LEVEL = &CILEVEL & LOWER BOUND = &LBOUND";
RUN;
%MEND EVDISP2;

%MACRO SMPDISP2;


DATA TAB;
   Z = PROBIT(SQRT(&CILEVEL/100));
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   SE = &SE;
   SM = &SM;
   MEAN = &MEAN;
   Q = &Q;
   MEANADJ = MEAN - Q;
   CILEVEL = &CILEVEL;
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   LLU = MEANADJ - Z *SQRT(MVAR / N);
%COMPUTE
     KEEP SE MEAN SM OVERBD;
PROC PRINT SPLIT='*';
 LABEL   SE = 'SAMPLE*WITHIN LOCATION*STD DEV'
         MEAN = 'SAMPLE*MEAN'
         SM = 'SAMPLE*BETWEEN LOCATION*STD DEV'
         OVERBD = 'LOWER BOUND';
  ID MEAN;
  VAR SE SM OVERBD;
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 "SAMPLING PLAN 2 (&LOC LOCATIONS, &NUM PER LOCATION)";
TITLE3 'PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST';
TITLE4 "WITH &CILEVEL.% ASSURANCE";
TITLE5 'GIVEN THE SAMPLE MEAN, WITHIN AND BETWEEN STD DEV';
RUN;
%MEND SMPDISP2;

%MACRO ANADISP2;
   
%IF %UPCASE(&A1DISP2)=Y %THEN %DO;
     %CALDISP2;
     %PRTDISP2;
    %END;
%IF %UPCASE(&A2DISP2)=Y %THEN %DO;
      %EVDISP2;
PROC DATASETS LIBRARY=WORK;
   DELETE SAVES2E;
    %END;
%IF %UPCASE(&A3DISP2)=Y %THEN %DO;
     %SMPDISP2;
    %END;
%MEND ANADISP2;

%ANADISP2

RUN;
%MEND DISP2;
%DISP2
